<?php
/**********************************************************************
 * ProxmoxVPS developed. (26.03.19)
 * *
 *
 *  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 **********************************************************************/

namespace ModulesGarden\Servers\ProxmoxVps\App\Http\Actions;

use ModulesGarden\ProxmoxAddon\App\Configuration\Addon\Update\AddonUpgradeService;
use ModulesGarden\ProxmoxAddon\App\Services\ApiService;
use ModulesGarden\ProxmoxAddon\App\Services\Vps\ProductService;
use ModulesGarden\Servers\ProxmoxVps\App\Helpers\AppParams;
use ModulesGarden\Servers\ProxmoxVps\App\Helpers\ProxmoxAddonValidator;
use ModulesGarden\Servers\ProxmoxVps\App\Http\Admin\Home;
use ModulesGarden\Servers\ProxmoxVps\App\UI\Validators\Validator;
use ModulesGarden\Servers\ProxmoxVps\Core\App\Controllers\Instances\AddonController;
use ModulesGarden\Servers\ProxmoxVps\Core\UI\Traits\WhmcsParams;

class AdminServicesTabFields extends AddonController
{
    use WhmcsParams;
    use ProductService;
    use ApiService;

    /**
     * @var AddonUpgradeService
     */
    private $addonUpgradeService;

    public function execute($params = null)
    {
        $action = $this->getRequestValue('mg-action') ? $this->request->get('mg-action') : 'index';

        if ($params['status'] != "Active" || !$params["customfields"]["vmid"])
        {
            return [];
        }
        try {
            ProxmoxAddonValidator::isInstalledOrFail();
            (new AppParams())->initFromWhmcsParams();
            $this->addonUpgradeService = new AddonUpgradeService();
            $this->addonUpgradeService->run();
            $this->vm()->status();
            return [Home::class, $action];
        } catch (\Exception $ex) {

            return ["Error" => "<span style='color: red'>" . $ex->getMessage() . "</span>"];
        }

    }
}